shell 脚本记录


1 shell 调试

sh -x somefile.sh

在somefile.sh 文件里加上set+x set-x

2 用 && || 简化if else

gzip -t a.tar.gz
if [[ 0 == $? ]]; then
     echo "good zip"
else
     echo "bad zip"
fi

可以简化为:

gzip  -t a.tar.gz && echo "good zip" || echo "bad zip"

3 判断文件非空

if [[ -s $file ]]; then
     echo "not empty"
fi

4 获取文件大小

stat -c %s $file
stat --printf='%s\n' $file
wc -c $file

5 字符串替换

${string//pattern/replacement}
a='a,b,c'
echo ${a//,/ /}

6 Contains 子字符串?

string="My string"
if [[ $string == *My* ]]; then
   echo "It's there!"
fi

7 rsync备份

rsync -r -t -v /source_folder /destination_folder
rsync -r -t -v /source_folder [user@host:/destination_folder

8 批量重命名文件

为所有txt文件加上.bak 后缀:

rename '.txt' '.txt.bak' *.txt

去掉所有的bak后缀:

rename '*.bak' '' *.bak

把所有的空格改成下划线:

find path -type f -exec rename 's/ /_/g' {
    
    } \;

把文件名都改成大写:

find path -type f -exec rename 'y/a-z/A-Z/' {
    
    } \;

9 for/while 循环

for ((i=0; i < 10; i++)); do echo $i; done
for line in $(cat a.txt); do echo $line; done
for f in *.txt; do echo $f; done
while read line ; do echo $line; done < a.txt
cat a.txt | while read line; do echo $line; done

10 删除空行

cat a.txt | sed -e '/^$/d'
(echo "abc"; echo ""; echo "ddd";) | awk '{if (0 != NF) print $0;}'

11 比较文件的修改时间

[[ file1.txt -nt file2.txt ]] && echo true || echo false #判断file1是否比file2新
[[ file1.txt -ot file2.txt ]] && echo true || echo false #判断file1是否比file2旧

12 实现Dictionary结构

hput() {
    
    
         eval "hkey_$1"="$2"
}
hget() {
    
    
         eval echo '${'"hkey_$1"'}'
         }
$ hput k1 aaa
$ hget k1
aaa

13 去掉第二列

$ echo 'a b c d e f' | cut -d ' ' -f1,3-
a c d e f

14 把stderr输出保存到变量

$ a=$( (echo 'out'; echo 'error' 1>&2) 2>&1 1>/dev/null)
$ echo $a
error

15 删除前3行

cat a.txt | sed 1,3d

16 读取多个域到变量

read a b c <<< "xxx yyy zzz"

17 遍历数组

array=( one two three )
for i in ${array[@]}
         do
echo $i
done

18 查看目录大小

du –sh ~/apps

19 查看CPU信息

cat /proc/cpuinfo

20 date

$ date +%Y-%m-%d
2012-12-24
$ date +%Y-%m-%d –date ‘-1 day'
2012-12-23
$ date +%Y-m-%d –date ‘Dec 25'
2011-12-25
$ date +%Y-m-%d –date ‘Dec 2510 days'
2011-12-15

21 获取路径名和文件名

$ dirname ‘/home/lalor/a.txt'
/home/lalor
$ basename ‘/home/lalor/a.txt'
a.txt

22 并集和交集

comm 可以用来求并集,交集,差集,假设现在有两个文件a和b,它们的内容如下:

$ cat a
1
3
5
$ cat b
3
4
5
6
7
$comm a b
1
3
4
5
6
7
$comm -1 -2 a b #交集
3
5
$comm a b | sed 's/\t//g' #并集
1
2
3
4
5
6
7
$comm -1 -3 a b | sed 's/\t//g' #b-a
4
6
7

23 awk复杂分隔符

多字符作分隔符

$ echo "a||b||c||d" | awk -F '[|][|]' '{print $3}'
   c

多种分隔符1

$echo "a||b,#c d" | awk -F '[| ,#]+' '{print $4}'
   d

多种分隔符2

$echo "a||b##c|#d" | awk -F '([|][|])|([#][#])' '{print $NF}'
   c|#d

24 产生一个随机数

echo $RANDOM

25 按照模式split 文件

csplit server.log /PATTERN/ -n 2 -s {
    
    *} -f server_result -b "%02d.log" -z

/PATTERN/ 用来匹配某一行,分割过程由此开始
{*} 根据匹配,重复执行分割
-s 静默模式
-n 分割后文件名后缀中,数字的个数
-f 分割后的文件名前缀
-b 指定后缀格式

26 获取文件名或者扩展名

var=hack.fun.book.txt
echo ${var%.*}
hack.fun.book
echo ${var%%.*}
hack
echo ${var#.*}
fun.book.txt
echo ${var##.*}
txt

27 以 root 帐户执行上一条命令

$sudo !!

其中:

!! 是指上一条命令

!$ 上一条命令的最后一个参数

!* 上一条命令的所有参数

!:3 上一条命令的第3个参数

例如:

$ls /tmp/somedir
  ls: cannot access /tmp/somedir: No such file or directory
$mkdir !$
  madir /tmp/somedir

28 利用 python 搭建一个简单的 Web 服务器,可通过 http://$HOSTNAME:8000 访问。

python -m SimpleHTTPServer

29 在 Vim 中无需权限保存编辑的文件。

:w !sudo tee %

30 将上一条命令中的 foo 替换为 bar,并执行。

^foo^bar

31 快速备份或复制文件。

cp filename{
    
    ,.bak}

32 将 ssh keys 复制到 user@Host 以启用无密码 SSH 登录

ssh-copy-id user@host

33 把 linux 桌面录制为视频

ffmpeg -f x11grab -s wxga -r 25 -i :0.0 -sameq /tmp/out.mpg

34 man 妙用

man ascii
man test

35 在 vim 中编辑上一条命令

fc

36 删除0 字节文件或垃圾文件

find . -type f -size 0 -delete
find . -type f -exec rm -rf {
    
    } \;
find . -type f -name "a.out" -exec rm -rf {
    
    } \;
find . type f -name "a.out" -delete
find . type f -name "*.txt" -print0 | xargs -0 rm -f

37 在编写SHELL 时显示多行信息

cat << EOF
+--------------------------------------------------------------+
| === Welcome to Tunoff services === |
+--------------------------------------------------------------+
EOF

注意,在指定结束符时,它必须是该行的唯一内容,并且该行必须以这个字符开头。

38 如何给mysql建软链接

cd /usr/local/mysql/bin
for i in *
do ln /usr/local/mysql/bin/$i /usr/bin/$i
done

39 获取IP地址:

ip addr|grep "global"|awk '{print $2}' |awk -F/ '{print $1}'

40 lsof工具

lsof abc.txt #显示开启文件abc.txt的进程
lsof -c abc #显示abc进程现在打开的文件
lsof -c -p 1234 #列出进程号为1234的进程所打开的文件
lsof -g gid #显示归属gid的进程情况
lsof +d /usr/local/ #显示目录下被进程开启的文件
lsof +D /usr/local/ #同上,但是会搜索目录下的目录,时间较长
lsof -d 4 #显示使用fd为4的进程
lsof -i #用以显示符合条件的进程情况
lsof `which httpd` #那个进程在使用apache的可执行文件
lsof /etc/passwd #那个进程在占用/etc/passwd
lsof -c sendmail #查看sendmail进程的文件使用情况
lsof -c courier -u ^zahn #显示出那些文件被以courier打头的进程打开,但是并不属于用户zahn
lsof -u1000 #查看uid是100的用户的进程的文件使用情况
lsof -utony #查看用户tony的进程的文件使用情况
lsof -i #显示所有打开的端口
lsof -i:80 #显示所有打开80端口的进程

41 清除僵尸进程

ps -eal | awk '{ if ($2 == "Z"){ print $4}}' | kill -9

42 打印唯一行

awk '!a[$0]++' file

43 打印奇数行

awk 'i=!i' file
awk 'NR%2' file

44 打印匹配行后的某一行

seq 10 | awk '/4/{f=4};--f==0{print;exit}'

45 打印某行后后面的10行

cat file | grep -A100 string
cat file | grep -B100 string #前面
cat file | grep -C100 string #前后

sed -n '/string/,+100p'

awk '/string/{f=100}--f>=0'

46 获取命令行最后一个参数

echo ${
    
    !#}
echo ${$#} #错误的尝试

47 输出重定向

将STDERR 和 STDOUT 的输出重定向到一个输出文件,为此,bash 提供了特殊的重定向符号 &>

ls file nofile &> /dev/null

我们如何在脚本里面重定向呢?没有什么特别之处,和普通重定向一样。

#!/bin/bash
#redirecting output to different locations
echo "now redirecting all output to another location" &>/dev/null

如果我们要将所有的输出都重定向到某个文件,不希望每次输出的时候都重定向。我们可以用exec 来永久重定向,如下所示:

#!/bin/bash
#redirecting output to different locations
exec 2>testerror
echo "This is the start of the script"
echo "now redirecting all output to another location"

exec 1>testout
echo "This output should go to testout file"
echo "but this should go the the testerror file" >& 2

输出结果如下所示:

This is the start of the script
now redirecting all output to another location
lalor@lalor:~/temp$ cat testout
This output should go to testout file
lalor@lalor:~/temp$ cat testerror
but this should go the the testerror file
lalor@lalor:~/temp$

以追加的方式重定向:

exec 3 >> testout

取消重定向:

exec 3> -

48 函数

任何地方定义的变量都是全局变量,如果要定义局部变量,需加local 关键字
shell中的函数也可以用递归

#!/bin/bash

  function factorial {
    
    
       if [[ $1 -eq 1 ]]; then
           echo 1
       else
           local temp=$[ $1 - 1 ]
           local result=`factorial $temp`
           echo $[ $result * $1 ]
       fi
   }

  result=`factorial 5`
   echo $result

创建函数库

将函数定一个在另一个文件,然后通过source 命令加载到当前文件

在命令行使用函数

将函数定义在~/.bashrc 中即可

向函数传递数组

#!/bin/bash
   #adding values in an array

  function addarray {
    
    
       local sum=0
       local newarray
       newarray=(`echo "$@"`)
       for value in ${newarray
}
       do
           sum=$[ $sum+$value ]
       done
       echo $sum
   }

  myarray=(1 2 3 4 5)
   echo "The original array is: ${myarray
}"
   arg1=`echo ${
     
     myarray
}`
   result=`addarray $arg1`
   echo "The result is $result"

49 正则表达式

匹配中文字符的正则表达式:[u4e00-u9fa5]
评注:匹配中文还真是个头疼的事,有了这个表达式就好办了
匹配双字节字符(包括汉字在内)[^x00-xff]
评注:可以用来计算字符串的长度(一个双字节字符长度计2,ASCII字符计1)
匹配空白行的正则表达式:^ *$
评注:可以用来删除空白行
匹配HTML标记的正则表达式:<(S*?)[^>]*>.*?</1>|<.*? />
评注:网上流传的版本太糟糕,上面这个也仅仅能匹配部分,对于复杂的嵌套标记依旧无能为力
匹配首尾空白字符的正则表达式:^s*|s*$
评注:可以用来删除行首行尾的空白字符(包括空格、制表符、换页符等等),非常有用的表达式
匹配Email地址的正则表达式:w+([-+.]w+)*@w+([-.]w+)*.w+([-.]w+)*
评注:表单验证时很实用
匹配网址URL的正则表达式:[a-zA-z]+://[^s]*
评注:网上流传的版本功能很有限,上面这个基本可以满足需求
匹配帐号是否合法(字母开头,允许5-16字节,允许字母数字下划线):^[a-zA-Z][a-zA-Z0-9_]{
    
    4,15}$
评注:表单验证时很实用
匹配国内电话号码:d{
    
    3}-d{
    
    8}|d{
    
    4}-d{
    
    7}
评注:匹配形式如0511-4405222或021-87888822
匹配腾讯QQ号:[1-9][0-9]{
    
    4,}
评注:腾讯QQ号从10000开始
匹配中国邮政编码:[1-9]d{
    
    5}(?!d)
评注:中国邮政编码为6位数字
匹配身份证:d{
    
    15}|d{
    
    18}
评注:中国的身份证为15位或18位
匹配ip地址:d+.d+.d+.d+
评注:提取ip地址时有用
匹配特定数字:
^[1-9]d*$  //匹配正整数
^-[1-9]d*$ //匹配负整数
^-?[1-9]d*$  //匹配整数
^[1-9]d*|0$ //匹配非负整数(正整数+ 0)
^-[1-9]d*|0$  //匹配非正整数(负整数+ 0)
^[1-9]d*.d*|0.d*[1-9]d*$  //匹配正浮点数
^-([1-9]d*.d*|0.d*[1-9]d*)$ //匹配负浮点数
^-?([1-9]d*.d*|0.d*[1-9]d*|0?.0+|0)$ //匹配浮点数
^[1-9]d*.d*|0.d*[1-9]d*|0?.0+|0$  //匹配非负浮点数(正浮点数+ 0)
^(-([1-9]d*.d*|0.d*[1-9]d*))|0?.0+|0$  //匹配非正浮点数(负浮点数+ 0)
评注:处理大量数据时有用,具体应用时注意修正
匹配特定字符串:
^[A-Za-z]+$  //匹配由26个英文字母组成的字符串
^[A-Z]+$  //匹配由26个英文字母的大写组成的字符串
^[a-z]+$  //匹配由26个英文字母的小写组成的字符串
^[A-Za-z0-9]+$  //匹配由数字和26个英文字母组成的字符串
^w+$  //匹配由数字、26个英文字母或者下划线组成的字符串

猜你喜欢

转载自blog.csdn.net/weixin_44021220/article/details/129585806